package dk.itu.oop.lecture8;

public class ExceptionTiming {
	public static void main(String[] args){
		ExceptionTiming et = new ExceptionTiming();
		et.timePip("Without Exceptions    ", 100000000, 1);
		et.timePip("With Exceptions       ", 1000000, 2);
		et.timePip("No ex, but finally     ", 100000000, 3);
	}

	void timePip(String msg, int N, int pipMethod){
		long start = System.currentTimeMillis();
		double time;
		switch(pipMethod){
			case 1: pip1(N);break;
			case 2: pip2(N);break;
			case 3: pip3(N);break;
		}
		time = System.currentTimeMillis()-start;
		System.out.println(msg + ": " + (time*1000)/N + " micro sec");
		System.out.println("Total time: " + time + " for " + N + " iterations");
	}

	void pip1(int N){
		for (int i = 0; i<N; i++)
			try{
				noUups();
			}catch(Exception e){
			}
	}

	void pip2(int N){
		for (int i = 0; i<N; i++)
			try{
				uups();
			}catch(Exception e){
			}
	}

	void pip3(int N){
		for (int i = 0; i<N; i++)
			try{
				noUups();
			}catch(Exception e){
			}finally{
			}
	}

	static Exception ohNo = new Exception("Oh no no");

	void uups() throws Exception{
		//throw new Exception("Oh no");
		ohNo.fillInStackTrace();
		throw ohNo;
	}

	void noUups() throws Exception{
		//new Exception("Oh no");
	}
}